SystemOrganization addCategory: #'Parcial Martn-Blas Avils'!

OrderedCollection variableSubclass: #Matriu
	instanceVariableNames: 'tamany'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial Martn-Blas Avils'!

!Matriu class methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/8/2012 12:29'!
new: unNombre

	unNombre > 0
	ifTrue: [
			|matriu| 
			matriu := super new: (unNombre*unNombre).
			matriu tamany: unNombre.
			matriu setContents: (matriu collector).
			^matriu]! !

!Matriu methodsFor: 'accessing' stamp: 'ChristianMartinBLas 11/8/2012 12:31'!
at: unParell

	|pos|
	pos := (unParell nColumna - 1) * self tamany + unParell nFila.
	^super at: pos.
	
	! !

!Matriu methodsFor: 'accessing' stamp: 'ChristianMartinBLas 11/8/2012 12:31'!
at: unParell put: unValor

	|pos|
	pos := (unParell nColumna - 1) * self tamany + unParell nFila.
	^super at: pos put: unValor.! !

!Matriu methodsFor: 'accessing' stamp: 'ChristianMartinBLas 11/8/2012 12:36'!
initialize

	1 to: (tamany*tamany) do: [:each | super at: each put: 0].! !

!Matriu methodsFor: 'accessing' stamp: 'ChristianMartinBLas 10/31/2012 17:48'!
tamany

	^ tamany! !

!Matriu methodsFor: 'accessing' stamp: 'ChristianMartinBLas 10/31/2012 17:50'!
tamany: unNombre

	tamany := unNombre! !

Object subclass: #ParcialMartinBlasAviles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial Martn-Blas Avils'!

!ParcialMartinBlasAviles methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 10/31/2012 17:43'!
pregunta1! !

!ParcialMartinBlasAviles methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/9/2012 12:42'!
pregunta2

"Introspecci: s la observaci prpia, durant l'execuci, de les seves metadades.
Intercessi: s la tcnica mitjanant la qual permet al codi interferir en l'execuci d'un programa.
Reificaci: s el mecanisme pel qual es codifica l'estat d'execuci com a dades."

"Smalltalk est ms a pror de ser reflexiu del tot que Java."

"Java no pot modificar directament els metaobjectes, en canvi Smalltalk si, per aix Java s menys reflexiu."

! !

!ParcialMartinBlasAviles methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/3/2012 14:34'!
pregunta3

"Les metaclasses sn necessaries tant Java com a Smalltalk perqu defineixen el comportament de les classes, perqu les classes sn les instancies de les metaclasses. Defineixen
el comportament de les classes perqu les metaclasses tenen el diccionari de mtodes, permeten crear instancies, etc. En el cas concret de Smalltalk tamb son necessaries perqu
com tot s un objecte, les classes tamb son objectes llavors necessiten una classe."

"La diferencia resideix en que la metaclasse de la classe Metaclass s Metaclass Class a Smaltalk i aix no ho t Java, la metaclasse de Java s java.lang.Class per aquesta no t metaclasse, simplement s instancia d'ella mateixa. La circularitat que es produeix a Smalltalk en la qesti de les metaclasses no s tan marcada a Java, en Smalltalk la metaclasse Metaclass s un objecte tamb i per tant s subclasse d'Object, per Object t una metaclasse que es instancia de Metaclass."

"Com a conseqencia tenim que no es pot accedir a la metaclasse de java.lang.Class a Java."! !

!ParcialMartinBlasAviles methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/9/2012 12:54'!
pregunta4

"Cas 1: 
	thisContext explore.
	^(1+1).


Cas 2:

	1 = 1 ifTrue: [thisContext explore. self halt.
	^(1+1).]"

"En el cas 1 es retorna al sender del MethodContext del mtode m, per tant, el mtode que ha cridat el missatge m."

"En el cas 2 el que passa s que el bloc es reifica en thisContext com un mtode diferente amb el seu MethodContext  i retorna al mtode m que avalua el bloc."

"Els elements de la pila d'execuci sn instncies de la classe MethodContext "! !

!ParcialMartinBlasAviles methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/3/2012 14:37'!
pregunta5

"haltIf: aSelector
	| context |
	context := thisContext.
	[context sender isNil]
		whileFalse:
			[context := context sender.
			(context selector = aSelector)
			ifTrue: [ Halt signal ] ]."! !

!ParcialMartinBlasAviles methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/3/2012 20:06'!
pregunta6

"Enganxo el codi del haltif en Java, de totes formes adjunto el .java amb el fitxer de text de l'entrega."

"

    public static void haltIf(String selector)
    {
       
        int longitud = (new Throwable()).getStackTrace().length;    
        for (int i = 0; i < longitud; i++)      //Recorrem la pila d'execuci per buscar si s'ha cridat a haltIf desde el mtode amb nom selector
        {
            String nomMetode = (new Throwable()).getStackTrace()[i].getMethodName();
            if(nomMetode.equals(selector)) 
            {
                System.exit(0); //Parem l'execuci
            }
        }
        
    }

"! !

Object subclass: #Parell
	instanceVariableNames: 'nFila nColumna'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Parcial Martn-Blas Avils'!

!Parell class methodsFor: 'as yet unclassified' stamp: 'ChristianMartinBLas 11/1/2012 16:53'!
nFila: unInteger nColumna: unInteger2

	^self new nFila: unInteger; nColumna: unInteger2.! !

!Parell methodsFor: 'accessing' stamp: 'ChristianMartinBLas 10/31/2012 17:47'!
nColumna

	^ nColumna! !

!Parell methodsFor: 'accessing' stamp: 'ChristianMartinBLas 11/1/2012 16:06'!
nColumna: unNombre

	nColumna := unNombre! !

!Parell methodsFor: 'accessing' stamp: 'ChristianMartinBLas 10/31/2012 17:47'!
nFila

	^ nFila! !

!Parell methodsFor: 'accessing' stamp: 'ChristianMartinBLas 10/31/2012 17:49'!
nFila: unNombre

	nFila := unNombre! !
